// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OWF/Processors.subproj/Protocols.subproj/OWMailToProcessor.h,v 1.4 1998/06/03 07:03:00 kc Exp $

#import "OWProcessor.h"

@class OWAddress;

// This is an abstract class which provides the fundamentals of parsing a mailto address, picking a good subject, etc.

// For this class to actually do anything, the -deliver method must be subclassed and the subclass must register itself as a process which converts url/mailto to Omni/Source.  (If multiple subclasses register themselves, the one with the lower cost wins.)

// The parameters dictionary will contain 

@interface OWMailToProcessor : OWProcessor
{
    OWAddress *mailToAddress;
    NSDictionary *parameterDictionary;
}

- (void)deliver;
    // This must be implemented by a subclass.  The mail parameters (to, subject, body) will have already been parsed into parameterDictionary.

@end

#import "FrameworkDefines.h"

// Use these keys to retrieve values from the parameter dictionary.

OWF_EXTERN NSString *OWMailToProcessorToParameterKey;
    // The "to" address

OWF_EXTERN NSString *OWMailToProcessorSubjectParameterKey;
    // The subject line

OWF_EXTERN NSString *OWMailToProcessorBodyParameterKey;
    // The message body
