// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OWF/Pipelines.subproj/OWWebPipeline.h,v 1.3 1998/07/02 19:34:26 wiml Exp $

#import "OWPipeline.h"

typedef enum {
    OWWebPipelineForwardHistoryAction,
    OWWebPipelineBackwardHistoryAction,
    OWWebPipelineReloadHistoryAction
} OWWebPipelineHistoryAction;

@interface OWWebPipeline : OWPipeline
{
    OWWebPipelineHistoryAction historyAction;
    OWContentInfo *referringContentInfo;
    id <OWAddress> referringAddress;

    struct {
        unsigned int proxyCacheDisabled:1;
    } webPipelineFlags;
}

- (OWWebPipelineHistoryAction)historyAction;
- (void)setHistoryAction:(OWWebPipelineHistoryAction)newHistoryAction;

- (id <OWAddress>)referringAddress;
- (void)setReferringAddress:(id <OWAddress>)anAddress;

- (OWContentInfo *)referringContentInfo;
- (void)setReferringContentInfo:(OWContentInfo *)anInfo;

- (BOOL)proxyCacheDisabled;
- (void)setProxyCacheDisabled:(BOOL)newDisabled;

@end
