// Copyright 1997-1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniFoundation/DataStructures.subproj/OFHeap.h,v 1.2 1998/08/04 21:39:10 kc Exp $

#import <Foundation/NSArray.h>

typedef struct {
    unsigned int value;
    NSObject *object;
} heapNode_t;

@interface OFHeap : NSObject
{
    heapNode_t *contents;
    unsigned int size, capacity;
}

- initWithCapacity:(unsigned int)newCapacity;

- (void)addObject:(NSObject *)anObject value:(unsigned int)aValue;

- (NSObject *)removeObject;
- (NSObject *)removeObjectWithValueLessThan:(unsigned int)aValue;

- (NSObject *)peekObject;
- (unsigned int)peekValue;

@end
