// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// private $Header: /Network/Developer/Source/CVS/OmniGroup/OmniFoundation/DataStructures.subproj/OFSignature.h,v 1.2 1998/09/20 04:38:38 bungi Exp $

#import "OFObject.h"

@class NSData;

// This is here so that those that want to define small buffers
// for a signature w/o yet having one can do so.
#define OF_SIGNATURE_LENGTH (20)

@interface OFSignature : OFObject
{
    void   *private;
    NSData *signatureData;
}

- initWithData: (NSData *) data;
- initWithBytes: (const void *) bytes length: (unsigned int) length;

- (void) addData: (NSData *) data;
- (void) addBytes: (const void *) bytes length: (unsigned int) length;

- (NSData *) signatureData;

@end
