// Copyright 1997 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniFoundation/OFSimpleLock-hppa.h,v 1.5 1998/08/04 20:14:29 kc Exp $

#define OFSimpleLockDefined

#import <mach/cthreads.h>

typedef unsigned int OFSimpleLockBoolean;

typedef struct {
    volatile unsigned int lock_data[4];
} OFSimpleLockType;

static inline void OFSimpleLockInit(OFSimpleLockType *simpleLock)
{
    *((volatile int *)(((int)(simpleLock) + 0x0c) & ~0x0f)) = 1;
}

#define OFSimpleLockFree(lock) /**/

static inline OFSimpleLockBoolean
OFSimpleLockTry(OFSimpleLockType *simpleLock)
{
    OFSimpleLockBoolean result;
    volatile int *lock_word;

    lock_word = (volatile int *)(((int)(simpleLock) + 0x0c) & ~0x0f);
    asm volatile (
    	"ldcws 0(%1),%0"
	    : "=r" (result)
	    : "r" (lock_word));
	    
    return result;
}

static inline void OFSimpleLock(OFSimpleLockType *simpleLock)
{
    do {
	while (*((volatile int *)(((int)(simpleLock) + 0x0c) & ~0x0f)) == 0) {
	    cthread_yield();
	    continue;
	}
    } while (!OFSimpleLockTry(simpleLock));
}

static inline void OFSimpleUnlock(OFSimpleLockType *simpleLock)
{
    *((volatile int *)(((int)(simpleLock) + 0x0c) & ~0x0f)) = 1;
}
