// Copyright 1998 Omni Development, Inc.  All rights reserved.
//
// $Header: /Network/Developer/Source/CVS/OmniGroup/OmniFoundation/OFZone.h,v 1.1 1998/09/09 00:57:26 wiml Exp $

#import "OFObject.h"

/* This is a simple OO wrapper around an NSZone pointer to allow refcounting (in particular, autoreleasing). When the OFZone is dealloced, it calls NSRecycleZone(). */

@interface OFZone : OFObject
{
    BOOL ownsZone;
@public
    NSZone *zone;
}

+ zoneForNSZone:(NSZone *)aZone;
+ defaultZone;
+ new;

/* Designated initializer; private API */
- _initWithNSZone:(NSZone *)aZone;

- (void)recycle;

- (NSZone *)nsZone;  /* NB: -[OFZone zone] returns the zone the OFZone is allocated *in*, not the zone it *represents* ! */

- (void)setName:(NSString *)newName;
- (NSString *)name;

@end
