/* OZLicense.h created by bungi on Wed 11-Feb-1998 */

#import <Foundation/Foundation.h>

#import "FrameworkDefines.h"

OmniZuul_EXTERN NSString *OZCannotReadLicenseException;
OmniZuul_EXTERN NSString *OZInvalidLicenseNotificationName;

OmniZuul_PRIVATE_EXTERN NSString *OZDateAddedLicenseKey;
OmniZuul_PRIVATE_EXTERN NSString *OZAddedByUserLicenseKey;

OmniZuul_PRIVATE_EXTERN NSString *OZOwnerNameLicenseKey;
OmniZuul_PRIVATE_EXTERN NSString *OZDataLicenseKey;

@class OZSeat;

@interface OZRuntimeLicense : NSObject
{
    BOOL          isValid;
    NSString     *path;
    NSMutableSet *seats;
    id            pd0;
    id            pd1;
}

+ (NSString *) licenseFileExtension;
+ (NSCharacterSet *) ownerNameIgnoreSet;
+ (void) prepareLicenseDictionary: (NSMutableDictionary *) dict;

- initWithContentsOfFile: (NSString *) path;
- initWithDictionary: (NSDictionary *) dict;

- (BOOL) writeToFile: (NSString *) file;

- (NSString *) path;

- (BOOL) isValid;
- (BOOL) isExpired;

- (id) valueForLicenseKeyStringWithKey: (NSString *) key;

- (NSNumber *) uniqueId;
- (NSString *) ownerName;
- (NSNumber *) numberOfSeats;
- (NSCalendarDate *) dateEntered;
- (NSCalendarDate *) expirationDate;

- (BOOL) containsSeat: (OZSeat *) aSeat;
- (void) addSeat: (OZSeat *) aSeat;
- (BOOL) hasUnclaimedSeats;

- (NSComparisonResult) betterThanLicense: (OZRuntimeLicense *) otherLicense;
// As an optional hook, applications can override this method in a category
// to have OmniZuul pick the 'best' available license.  The default
// implementation ranks all licenses as of equal goodness.  If this is sent
// to the better license, it should return NSOrderedAscending.

@end
